import Color from 'color';
export declare const genID: () => string;
export declare const mapText2Color: (txt: string) => string;
export declare enum ObjectEvent {
    MouseOut = "mouseout",
    MouseOver = "mouseover",
    MouseDown = "mousedown",
    MouseUp = "mouseup",
    MouseDoubleClick = "mousedblclick",
    Moving = "moving"
}
export interface StateRule {
    metadata: {
        x: number;
        y: number;
    };
    events: Record<string, string>;
}
export interface StateMachine {
    initialState: string;
    rules: Record<string, StateRule>;
}
export declare const ELEMENT_EVENTS: {
    stateMachineChange: string;
    state: {
        click: string;
        rightClick: string;
        over: string;
        out: string;
        doubleClick: string;
    };
    transition: {
        click: string;
        rightClick: string;
        over: string;
        out: string;
        doubleClick: string;
    };
    canvas: {
        click: string;
        rightClick: string;
        doubleClick: string;
    };
};
export declare const EDITOR_DEFAULTS: {
    stateFill: Color<"#180019">;
    stateStroke: Color<"#C5CBD3">;
    initialStateStroke: Color<"orange">;
    currentStateFill: Color<"#400042">;
    textStroke: Color<"white">;
    backgroundColor: Color<"#330031">;
    selectionColor: Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | Color<string | number | any | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }> | ArrayLike<number> | {
        [key: string]: any;
    }>;
    selfLinkHeight: number;
    stateRadius: number;
    maxZoom: number;
    minZoom: number;
    selectableStates: boolean;
};
export interface EditorOptions {
    stateRadius?: number;
    stateFill?: Color;
    stateStroke?: Color;
    initialStateStroke?: Color;
    currentStateFill?: Color;
    textStroke?: Color;
    backgroundColor?: Color;
    selectionColor?: Color;
    selfLinkHeight?: number;
    selectableStates?: boolean;
    maxZoom?: number;
    minZoom?: number;
}
