"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const color_1 = __importDefault(require("color"));
const uuid_1 = require("uuid");
const color_hash_1 = __importDefault(require("color-hash"));
const colorHash = new color_hash_1.default();
exports.genID = () => uuid_1.v1();
exports.mapText2Color = (txt) => colorHash.hex(txt);
var ObjectEvent;
(function (ObjectEvent) {
    ObjectEvent["MouseOut"] = "mouseout";
    ObjectEvent["MouseOver"] = "mouseover";
    ObjectEvent["MouseDown"] = "mousedown";
    ObjectEvent["MouseUp"] = "mouseup";
    ObjectEvent["MouseDoubleClick"] = "mousedblclick";
    ObjectEvent["Moving"] = "moving";
})(ObjectEvent = exports.ObjectEvent || (exports.ObjectEvent = {}));
exports.ELEMENT_EVENTS = {
    stateMachineChange: 'statemachine:change',
    state: {
        click: 'state:click',
        rightClick: 'state:rightclick',
        over: 'state:over',
        out: 'state:out',
        doubleClick: 'state:doubleclick',
    },
    transition: {
        click: 'transition:click',
        rightClick: 'transition:rightclick',
        over: 'transition:over',
        out: 'transition:out',
        doubleClick: 'transition:doubleclick',
    },
    canvas: {
        click: 'canvas:click',
        rightClick: 'canvas:rightclick',
        doubleClick: 'canvas:doubleclick',
    },
};
exports.EDITOR_DEFAULTS = {
    stateFill: new color_1.default('#180019'),
    stateStroke: new color_1.default('#C5CBD3'),
    initialStateStroke: new color_1.default('orange'),
    currentStateFill: new color_1.default('#400042'),
    textStroke: new color_1.default('white'),
    backgroundColor: new color_1.default('#330031'),
    selectionColor: new color_1.default(),
    selfLinkHeight: 100,
    stateRadius: 30,
    maxZoom: 20,
    minZoom: 0.01,
    selectableStates: true,
};
