import { StateRule, StateMachine } from './common';
export default class StateMachineEditor extends HTMLElement {
    #private;
    stateMachineRules: Record<string, StateRule>;
    constructor();
    connectedCallback(): void;
    get stateMachine(): StateMachine;
    set stateMachine(value: StateMachine);
    get currentState(): string | null;
    set currentState(value: string | null);
    get width(): string | null;
    set width(newWidth: string | null);
    get height(): string | null;
    set height(newHeight: string | null);
    static get observedAttributes(): string[];
    attributeChangedCallback(name: string, _oldValue: string, newValue: string): void;
    private initialRender;
    setCurrentState(value: string): void;
    setStateMachine({ initialState, rules }: StateMachine): void;
    addState(name: string, x: number, y: number): void;
    setInitialState(name: string): void;
    deleteState(name: string): void;
    deleteTransition(id: string): void;
    startAddTransition(event: string, srcName: string, destX: number, destY: number): void;
    stopAddTransition(): void;
    setCanvasSize(width: number, height: number): void;
    setHeight(height: number): void;
    setWidth(width: number): void;
    setHoverCursor(cursor: string): void;
    getStateMachine(): StateMachine;
    private dispatchCustomEvent;
    private updateAllObjects;
    private handleMouseWheel;
    private handleMouseDown;
    private handleMouseUp;
    private handleMouseMove;
    private handleDoubleClick;
    private handleStateMachineChange;
    private handleStateMove;
    private handleStateDoubleClick;
    private handleStateMouseOver;
    private handleStateMouseOut;
    private handleStateClick;
    private handleStateMouseUp;
    private handleTransitionClick;
    private handleTransitionOver;
    private handleTransitionOut;
    private handleTransitionDoubleClick;
    private drawState;
    private drawTransition;
}
