import { fabric } from 'fabric';
import { ObjectEvent } from './common';
import Color from 'color';
export default class State {
    #private;
    static initialStateStroke: Color;
    static activeStateFill: Color;
    static stateStroke: Color;
    static stateFill: Color;
    static textStroke: Color;
    static stateRadius: number;
    get name(): string;
    get id(): string;
    get position(): {
        x: number;
        y: number;
    };
    get initial(): boolean;
    set initial(value: boolean);
    get active(): boolean;
    set active(value: boolean);
    constructor(ctx: fabric.Canvas, name: string, x: number, y: number, { initial, active }?: {
        initial?: boolean | undefined;
        active?: boolean | undefined;
    });
    on(event: ObjectEvent, handler: (opt: fabric.IEvent, state: State) => void): void;
    remove(): void;
    render(): void;
    setCoords(): void;
}
