import { fabric } from 'fabric';
import State from './state';
import { ObjectEvent } from './common';
export interface TransitionOption {
    src?: State;
    dest?: State;
    defaultX?: number;
    defaultY?: number;
}
export default class NewTransition {
    #private;
    static selfLinkHeight: number;
    get src(): State | null;
    set src(value: State | null);
    get dest(): State | null;
    set dest(value: State | null);
    get name(): string;
    get id(): string;
    set defaultDest(value: {
        x: number;
        y: number;
    });
    get defaultDest(): {
        x: number;
        y: number;
    };
    constructor(ctx: fabric.Canvas, name: string, { src, dest, defaultX, defaultY }?: TransitionOption);
    private render;
    private rerender;
    remove(): void;
    setCoords(): void;
    on(event: ObjectEvent, handler: (opt: fabric.IEvent, transition: NewTransition) => void): void;
    private calcLinkPath;
    private calcPointerPath;
    private calcSelfLinkPath;
    private calcTransitionLink;
}
